**********************************************************
*                      2000 Census                       *
*Program originates 1 database with migration information*
**********************************************************;
libname use 'E:\demo\paper\data\2000';
options obs=max nocenter pagesize=max;
filename census 'E:\data\Brazil\Census\2000\pes*.txt';

data use.br;
  infile census lrecl=349 pad;

  input
  v0102 001-002    /*state of residence*/
  v0401 069        /*sex*/
  v4752 079-081    /*age*/
  v0422 122-123    /*time of residence in current state*/
  v4230 125-126    /*state of previous residence*/
  v4260 138-139    /*state of residence on July 31, 1995*/
  p001  335-345 .8 /*individual weight with 8 decimal places*/
;

/*sex*/
if v0401 = 1 then sex = 0; /*male*/
  else if v0401 = 2 then sex = 1; /*female*/

/*age group*/
if v4752 >= 85 then age = 85; /*85+*/
  else age = v4752 - (mod(v4752,5)); /*other age groups*/

/*state of residence*/
stres = v0102;

/*state of previous residence*/
if v4230 = . then stprev = stres; /*non-migrant*/
  else if v4230 =  1 then stprev = 11; /*rondonia*/
  else if v4230 =  2 then stprev = 12; /*acre*/
  else if v4230 =  3 then stprev = 13; /*amazonas*/
  else if v4230 =  4 then stprev = 14; /*roraima*/
  else if v4230 =  5 then stprev = 15; /*para*/
  else if v4230 =  6 then stprev = 16; /*amapa*/
  else if v4230 =  7 then stprev = 17; /*tocantins*/
  else if v4230 =  8 then stprev = 21; /*maranhao*/
  else if v4230 =  9 then stprev = 22; /*piaui*/
  else if v4230 = 10 then stprev = 23; /*ceara*/
  else if v4230 = 11 then stprev = 24; /*rio grande do norte*/
  else if v4230 = 12 then stprev = 25; /*paraiba*/
  else if v4230 = 13 then stprev = 26; /*pernambuco*/
  else if v4230 = 14 then stprev = 27; /*alagoas*/
  else if v4230 = 15 then stprev = 28; /*sergipe*/
  else if v4230 = 16 then stprev = 29; /*bahia*/
  else if v4230 = 17 then stprev = 31; /*minas gerais*/
  else if v4230 = 18 then stprev = 32; /*espirito santo*/
  else if v4230 = 19 then stprev = 33; /*rio de janeiro*/
  else if v4230 = 20 then stprev = 35; /*sao paulo*/
  else if v4230 = 21 then stprev = 41; /*parana*/
  else if v4230 = 22 then stprev = 42; /*santa catarina*/
  else if v4230 = 23 then stprev = 43; /*rio grande do sul*/
  else if v4230 = 24 then stprev = 50; /*mato grosso do sul*/
  else if v4230 = 25 then stprev = 51; /*mato grosso*/
  else if v4230 = 26 then stprev = 52; /*goias*/
  else if v4230 = 27 then stprev = 53; /*distrito federal*/
  else if v4230 = 29 then stprev = .;  /*brazil not specified*/
  else if 30 <= v4230 <= 99 then stprev = .; /*other countries*/
  else if v4230 = 00 then stprev = .; /*unknown*/

/*state of residence on July 31, 1995*/
if v4260 = . and 0<=v4752<=4 then stfix = .; /*people below five years of age*/
  else if v4260 =  . and v4752>= 5 then stfix = stres; /*always lived in current municipality; or lived in this municipality at that time*/
  else if v4260 =  1 then stfix = 11; /*rondonia*/
  else if v4260 =  2 then stfix = 12; /*acre*/
  else if v4260 =  3 then stfix = 13; /*amazonas*/
  else if v4260 =  4 then stfix = 14; /*roraima*/
  else if v4260 =  5 then stfix = 15; /*para*/
  else if v4260 =  6 then stfix = 16; /*amapa*/
  else if v4260 =  7 then stfix = 17; /*tocantins*/
  else if v4260 =  8 then stfix = 21; /*maranhao*/
  else if v4260 =  9 then stfix = 22; /*piaui*/
  else if v4260 = 10 then stfix = 23; /*ceara*/
  else if v4260 = 11 then stfix = 24; /*rio grande do norte*/
  else if v4260 = 12 then stfix = 25; /*paraiba*/
  else if v4260 = 13 then stfix = 26; /*pernambuco*/
  else if v4260 = 14 then stfix = 27; /*alagoas*/
  else if v4260 = 15 then stfix = 28; /*sergipe*/
  else if v4260 = 16 then stfix = 29; /*bahia*/
  else if v4260 = 17 then stfix = 31; /*minas gerais*/
  else if v4260 = 18 then stfix = 32; /*espirito santo*/
  else if v4260 = 19 then stfix = 33; /*rio de janeiro*/
  else if v4260 = 20 then stfix = 35; /*sao paulo*/
  else if v4260 = 21 then stfix = 41; /*parana*/
  else if v4260 = 22 then stfix = 42; /*santa catarina*/
  else if v4260 = 23 then stfix = 43; /*rio grande do sul*/
  else if v4260 = 24 then stfix = 50; /*mato grosso do sul*/
  else if v4260 = 25 then stfix = 51; /*mato grosso*/
  else if v4260 = 26 then stfix = 52; /*goias*/
  else if v4260 = 27 then stfix = 53; /*distrito federal*/
  else if v4260 = 29 then stfix = .;  /*brazil not specified*/
  else if 30 <= v4260 <= 99 then stfix = .; /*other countries*/

/*migrant or non-migrant*/
if v0422 = . then migrant = 0; /*non-migrant*/
  else if v0422 >= 5 then migrant = 0; /*non-migrant: 5 years or more of residence*/
  else if 0 <= v0422 <= 4 then migrant = 1; /*migrant: 0-4 years of residence*/

/*original weight*/
original = p001;

/*region of residence*/
if 11 <= stres <= 17 then region = 1; /*north*/
  else if 21 <= stres <= 29 then region = 2; /*northeast*/
  else if 31 <= stres <= 35 then region = 3; /*southeast*/
  else if 41 <= stres <= 43 then region = 4; /*south*/
  else if 50 <= stres <= 53 then region = 5; /*central-west*/

/*region of previous residence*/
if 11 <= stprev <= 17 then regprev = 1; /*north*/
  else if 21 <= stprev <= 29 then regprev = 2; /*northeast*/
  else if 31 <= stprev <= 35 then regprev = 3; /*southeast*/
  else if 41 <= stprev <= 43 then regprev = 4; /*south*/
  else if 50 <= stprev <= 53 then regprev = 5; /*central-west*/

/*region of residence on July 31, 1995*/
if 11 <= stfix <= 17 then regfix = 1; /*north*/
  else if 21 <= stfix <= 29 then regfix = 2; /*northeast*/
  else if 31 <= stfix <= 35 then regfix = 3; /*southeast*/
  else if 41 <= stfix <= 43 then regfix = 4; /*south*/
  else if 50 <= stfix <= 53 then regfix = 5; /*central-west*/

run;
