clear
set more off
set mem 500m
log using "E:\demo\paper\programs\07-ter_prev_region.log", replace text

use "E:\demo\paper\data\regprev\table.dta", clear

drop asner*
sort regprev region sex

***Calculate total emigration rate (TER)
by regprev region sex: egen tner00 = sum(aser00)
replace tner00=exp(-1*tner00)
gen ter00=1-tner00

***Recode sex variable
gen female=sex
gen male=.
replace male=1 if sex==0
replace male=0 if sex==1

***List TER between Northeast and Southeast
keep if (age==0) & (regprev==2|regprev==3) & (region==2|region==3)
list regprev region male ter00

save "E:\demo\paper\data\regprev\ter.dta", replace

log close
